%algoritmo de inversion lineal para una corteza oceanica magnetizada

clear all
close all
clc

%definicion de la geometria del campo magnetico
a=500;
b=500;
R=sqrt((a*b)/pi); 
xi=-50*R:2*R:50*R;
xj=min(xi):200:max(xi);
I=input('ingrese inclinacion (-30º)');
if(isempty(I));I=-30; end;
h=input('ingrese profundidad [m] (50)');
if(isempty(h));h=50; end;
I=I*pi/180; 
fact1=cos(I)^2-sin(I)^2; 
fact2=2*cos(I)*sin(I);

% definicion de dominio observaciones-parametros
[XI,XJ]=meshgrid(xi,xj); 
R4=((XJ-XI).^2+h*h).^2;
N1=(XJ-XI).^2-h*h; 
N2=2*(XJ-XI)*h;
func=2*pi*R*R*((fact1*N1./R4)+(fact2*N2./R4));

% definición de vector de magnetización por función aleatoria
M=sign( random('Normal',0,0.5,length(xi),1) )*500;
T=func*M;
figure(1)
    subplot(3,1,1)
        plot(xj/1000,T);
        xlabel('Distancia (km)')
        title('Campo magnetico (nT)'); 
        grid on
    subplot(3,1,2)
        bar(xi/1000,M/500);
        xlabel('Distancia (km)') 
        title('Polaridad');
        axis([-15 15 -2 2])
        grid on

% inversion de parametros
M_est=inv(func'*func)*func'*T;

    subplot(3,1,3)
        plot(xi/1000,M,'r*',xi/1000,M_est,'o-');
        title('Magnetización');
        xlabel('Distancia (km)')
        grid on


% % Incorporacion de ruido aletorio de un 1% en la señal
% TT=T+(max(T) - min(T))*0.01*random('Normal',0,0.5,length(xj),1);
% figure(2)
%     subplot(3,1,1)
%         plot(xj/1000,T,xj/1000,TT);
%         title('campo magnetico');
%     subplot(3,1,2)
%         bar(xi/1000,M/500);
%         title('polaridad');
%         axis([-15 15 -2 2])
% % inversion de parametros
% M_est=inv(func'*func)*func'*TT;
% subplot(3,1,3),plot(xi/1000,M,xi/1000,M_est,'.-');
% title('magnetización');
% 
% [U,S,V]=svd(func);
% m_est_1=(V(:,1:30)*inv(S(1:30,1:30))*U(:,1:30)')*TT;
% m_est_1=(V(:,1:20)*inv(S(1:20,1:20))*U(:,1:20)')*TT;
% m_est_1=(V(:,1:10)*inv(S(1:10,1:10))*U(:,1:10)')*TT;