% Ajusta plano a datos d = d(x,y)  por minimos cuadrados, segun el modelo:
%
% d = m(1) + m(2)*x + m(3)*y
%
% Ver pp. 44-45, Geophysical Data Analysis: Discrete Inverse Theory, Menke
%
% Datos de entrada:    x,y,d ; los 3 vectores columna o fila
% Resultado de ajuste: m; vector columna m = [ m(1);m(2);m(3) ] 
%
function m = fitplane(x,y,d)
%
n   = length(x);
sx  = sum(x);
sy  = sum(y);
sd  = sum(d);
sx2 = sum(x.*x);
sy2 = sum(y.*y);
sxy = sum(x.*y);
sxd = sum(x.*d);
syd = sum(y.*d);
%
GTd = [sd;sxd;syd];
GTG  = [n,sx,sy;sx,sx2,sxy;sy,sxy,sy2];
m    = inv(GTG) * GTd;
