clc
clear all
close all

%parametros iniciales del dique
x=-10:0.1:10;
h=2;
d=2;
susc=1e-3;
inc=30;
dec=70;
f0=2.5*1e3;

%anomalia a invertir
[T]=campo_dique(x,h,d,susc,f0,inc,dec);
%parametros con los cuales iniciar la inversion
h1=h/1.5; d1=d*2.5; susc1=susc/1.5;

m=1;
% numero de iteraciones
numiter=20;
for l=1:numiter
    [T1]=campo_dique(x,h1,d1,susc1,f0,inc,dec);
    [G1]=mat_der(x,h1,d1,susc1,f0,inc,dec);
    par=[susc1,h1,d1]'+inv(G1'*G1)*G1'*(T-T1)';
    susc1=par(1); h1=par(2); d1=par(3);
    
    %se guardan las diversas iteraciones
    g=[susc1 h1 d1]
    gg(:,m)=g;
    m=m+1;
end

%grafico de los diversos diques invertidos
figure(1)
hold on
for m=1:numiter
   % subplot(numiter,1,m)
    plot(x,campo_dique(x,gg(2,m),gg(3,m),gg(1,m),f0,inc,dec))
    grid on
   % legend(['Iteracion ',num2str(m)])
end
[T]=campo_dique(x,h,d,susc,f0,inc,dec);
plot(x,T,'r.')

figure(2)
    hold on
    %grafico del nuevo dique invertido
    [T]=campo_dique(x,h1,d1,susc1,f0,inc,dec);
    plot(x,T,'r.')
    %grafico del dique original
    [T]=campo_dique(x,h,d,susc,f0,inc,dec);
    plot(x,T,'b-')
    grid on
    legend('Dique Invertido','Dique Sintetico')
    title('Anomalia de campo total de un dique')
    ylabel('Anomalia magnetica (nT)')
    xlabel('Distancia (km)')
