% Proyecta conjunto de puntos (x,y) sobre recta de mejor ajuste
%
% id >=  0, define coordenada lineal s en el sentido creciente de x (de W -> E)
% id <   0, define coordenada lineal s en el sentido creciente de y (de S -> N)
function [xp,yp,s] = proyectxy(x,y,id)
%
% Ajustar recta a Ptos. por minimos cuadrados
%
n   = length(x);
s   = x;
a   = polyfit(x,y,1);
% Proyectar perfil sobre recta de mejor ajuste
%
xp   = ( a(1)*y + x - a(1)*a(2) )/(1 + a(1)^2);
yp   = a(1)*xp + a(2);
% Definicion de Geometria unidimensional a lo largo
% de la recta de mejor ajuste
%
xref  = xp(1);
yref  = yp(1);
for k = 1:n,
    s(k)  = sqrt( (xp(k)-xref)^2 + (yp(k)-yref)^2 );
    if id >= 0
        if xp(k) < xref
            s(k) = -s(k);
        end
    else
        if yp(k) < yref
            s(k) = -s(k);
        end
    end
end